
-- Turbine Imports..
import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";


function ShowTurbineColors()

	wColorWindow = Turbine.UI.Lotro.Window();
	wColorWindow:SetPosition(100,100);
	wColorWindow:SetSize(250,420);
	wColorWindow:SetText("Colors");
	wColorWindow:SetVisible(true);

	wColorListBox = Turbine.UI.ListBox();
	wColorListBox:SetParent(wColorWindow);
	wColorListBox:SetSize(200,350);
	wColorListBox:SetPosition(20,40);

	wColorListScroll = Turbine.UI.Lotro.ScrollBar();
    wColorListScroll:SetOrientation(Turbine.UI.Orientation.Vertical);
    wColorListScroll:SetParent(wColorWindow);
    wColorListScroll:SetPosition(wColorListBox:GetLeft() + wColorListBox:GetWidth(),wColorListBox:GetTop());
    wColorListScroll:SetSize(8,wColorListBox:GetHeight());
	wColorListScroll:SetVisible(false);

    wColorListBox:SetVerticalScrollBar(wColorListScroll);


	local _TEMPCOLORTABLE = {};

	for k,v in pairs (Turbine.UI.Color) do
		if k ~= "Constructor" and k ~= "IsA" then
			table.insert(_TEMPCOLORTABLE,k);
		end
	end

	table.sort(_TEMPCOLORTABLE);


	for k,v in pairs (_TEMPCOLORTABLE) do

		local tempCOLORCONTROL = Turbine.UI.Control();
		tempCOLORCONTROL:SetSize(wColorListBox:GetWidth(),50);

		local tempCOLORLABEL = Turbine.UI.Label();
		tempCOLORLABEL:SetParent(tempCOLORCONTROL);
		tempCOLORLABEL:SetSize(wColorListBox:GetWidth(),tempCOLORCONTROL:GetHeight()-3);
		tempCOLORLABEL:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
		tempCOLORLABEL:SetFont(Turbine.UI.Lotro.Font.Verdana14);
		tempCOLORLABEL:SetForeColor(Turbine.UI.Color.White);
		tempCOLORLABEL:SetOutlineColor(Turbine.UI.Color.Black);
		tempCOLORLABEL:SetFontStyle(Turbine.UI.FontStyle.Outline);
		tempCOLORLABEL:SetBackColor(Turbine.UI.Color[v]);
		tempCOLORLABEL:SetText(v .. "\n#" .. HexTBColor(Turbine.UI.Color[v]));

		wColorListBox:AddItem(tempCOLORCONTROL);

	end

end


function RegisterCommands()

	---------------------------------------------------------------------------------------------

	-- COMMAND TO DISPLAY / HIDE THE MAIN WINDOW.
	cmdMainWin = Turbine.ShellCommand();

	function cmdMainWin:Execute( command, arguments )

		wColorWindow:SetVisible(true);
	end

	function cmdMainWin:GetHelp()
		return "Colors: Shows the color palette";
	end

	function cmdMainWin:GetShortHelp()
		return "Colors: Shows the color palette";
	end

	Turbine.Shell.AddCommand( "colorpalette", cmdMainWin);


	Turbine.Shell.WriteLine("Use command /colorpalette if you close the window");

	---------------------------------------------------------------------------------------------


end


-- This function takes a turbine color and returns the appropriate hex value for that color to be used in RGB tags
function HexTBColor(TURBINECOLOR)
	local function HEXRGB(IN)
	local B,K,OUT,I,D=16,"0123456789ABCDEF","",0
		if IN == 0 then return "00" end;
		while IN>0 do
		I=I+1
		IN,D=math.floor(IN/B),math.mod(IN,B)+1
		OUT=string.sub(K,D,D)..OUT
	end
	if string.len(OUT) == 1 then OUT = "0" .. OUT end;
		return OUT
	end
	return HEXRGB(math.ceil(TURBINECOLOR.R*255)) .. HEXRGB(math.ceil(TURBINECOLOR.G*255)) .. HEXRGB(math.ceil(TURBINECOLOR.B*255));
end


ShowTurbineColors();
RegisterCommands();
